$:.unshift File.join(File.dirname(__FILE__), "..", "lib")

require 'test/unit'
require 'test_generic'

class TC_TestEvent < TestGeneric

  require 'crdb/event'

  connect_info = TestGeneric.make_dev_session()

  # Initialize
  ClassName = 'CRDB::Event' 
  classname = TestGeneric.get_classname(ClassName)
  classname.initialize_fake_method_to_value_hash()

  # Clean up any left-over fake records
  classname.delete_all_fakes()

  @@fake_m2v_hash = nil
  def setup
    @@fake_m2v_hash = TestGeneric.get_fake_method_to_value_hash(ClassName) 
  end

  # TEST: Create an object
  def test_00_new
    X_test_new(ClassName)
  end

  # TEST: Create an object and populate it
  def test_01_populate
    X_test_populate(ClassName, 'arg1', @@fake_m2v_hash['arg1'][0])
  end

  # TEST: Create an object and save it (then delete it). 
  def test_02_create
    X_test_create(ClassName, 'arg1', @@fake_m2v_hash['arg1'][0])
  end

  # TEST: Try and save some fields in the wrong format
  def test_04_code_wrong_format
    bad_sunetids = [
                 '1adamhl',   
                 'adaMHL',   
                 'adamhl_1',   
                ] 
    X_test_field_validity(ClassName, 'sunetid', bad_sunetids)
  end

  # TEST: CLEANUP
  def test_99_cleanup
    CRDB::Event.delete_all_fakes()
  end

end