$:.unshift File.join(File.dirname(__FILE__), "..", "lib")

require 'test/unit'
require 'test_generic'

class TC_TestEventcode < TestGeneric

  require 'crdb/eventcode'

  connect_info = TestGeneric.make_dev_session()

  # Initialize
  ClassName = 'CRDB::Eventcode'
  classname = TestGeneric.get_classname(ClassName)
  classname.initialize_fake_method_to_value_hash()

  # Clean up any left-over fake records
  classname.delete_all_fakes()

  @@fake_m2v_hash = nil
  def setup
    @@fake_m2v_hash = TestGeneric.get_fake_method_to_value_hash(ClassName) 
  end

  # TEST: Create an object
  def test_00_new
    X_test_new(ClassName)
  end

  # TEST: Create an object and populate it
  def test_01_populate
    X_test_populate(ClassName, 'code', @@fake_m2v_hash['code'][0])
  end

  # TEST: Create an object and save it (then delete it). 
  def test_02_create
    X_test_create(ClassName, 'code', @@fake_m2v_hash['code'][0])
  end

  # TEST: Test uniqueness of some of the fields.
  def test_03_uniqueness
    X_test_field_uniqueness(ClassName, 'code')
  end

  # TEST: Try and save with with some validation errors.
  def test_04_validation_tests
    bad_codes = [
                 '',            # Empty
                 'E_VJJJ_JJJ', 
                 'EV_', 
                 'EV_Aa', 
                 'ev_AA', 
                ] 
    X_test_field_validity(ClassName, 'code', bad_codes)
  end

end
