module CRDB
 class Adminownership < ActiveRecord::Base

  require 'crdb/adminunit'
  require 'crdb/resource'

  # Foreign keys
  belongs_to :resource, :class_name => "CRDB::Resource"
  belongs_to :adminunit, :class_name => "CRDB::Adminunit"

  ## VALIDATIONS
  validates :resource_id, :uniqueness => { :scope => :adminunit_id }
#  validates_presence_of :adminunit, :message => " must be specified"
#  validates_presence_of :resource, :message => " must be specified"
#  validates_uniqueness_of :resource_id, :scope => :adminunit_id
#  validates_uniqueness_of :adminunit_id, :scope => :resource_id

  def to_s
    resource = self.resource
    adminunit = self.adminunit

    if (!resource.nil?)
      resource_formatted = resource.to_s
    else
      resource_formatted = 'NO RESOURCE'
    end

    if (!adminunit.nil?)
      adminunit_formatted = adminunit.to_s
    else
      adminunit_formatted = 'NO ADMIN UNITS'
    end

    return resource_formatted + "\n" + adminunit_formatted
  end


  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###
  # "Mix-in" the Fake module
  require 'crdb/fake.rb'
  include CRDB::Fake

  @@fake_method_to_value_hash = nil
  def (CRDB::Adminownership).initialize_fake_method_to_value_hash()
    (CRDB::Adminunit).delete_all_fakes()
    adminunit = (CRDB::Adminunit).new()
    fake_adminunit0 = adminunit.make_fake({:index => 0})
    fake_adminunit1 = adminunit.make_fake({:index => 1})
    fake_adminunits = [fake_adminunit0, fake_adminunit1]

    (CRDB::Resource).delete_all_fakes()
    resource = (CRDB::Resource).new()
    fake_resource0 = resource.make_fake({:index => 0})
    fake_resource1 = resource.make_fake({:index => 1})
    fake_resources = [fake_resource0, fake_resource1]

    @@fake_method_to_value_hash =
    {
      'adminunit'   => fake_adminunits,
      'resource'    => fake_resources,
    }
  end

  def (CRDB::Adminownership).get_fake_method_to_value_hash()
    return @@fake_method_to_value_hash
  end


  def (CRDB::Adminownership).delete_all_fakes()
    (CRDB::Adminownership).initialize_fake_method_to_value_hash()
    fake_adminunits = @@fake_method_to_value_hash['adminunit']
    (CRDB::Adminownership).delete_all(["adminunit_id = ?", fake_adminunits[0].id])
    (CRDB::Adminownership).delete_all(["adminunit_id = ?", fake_adminunits[1].id])
    (CRDB::Resource).delete_all_fakes()
    (CRDB::Adminunit).delete_all_fakes()
  end
  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###


 end # matches "class Adminownership"
end # matches "module CRDB"
