module CRDB
  class Category < ActiveRecord::Base

  # There is a one-to-many relationship between categories and types.
  has_many :types, :class_name => "CRDB::Type"

  ## VALIDATIONS
  validates_format_of :code, :with => /\A[a-z]{2}\z/


  def to_s
    @id = self.id
    @code = self.code
    @description = self.description
    return "(id: #{@id}, code: #{@code}, description: #{@description})"
  end

  def location?
    @code = self.code
    if (code =~ /\Alo\z/)
      return true
    else
      return false
    end
  end

  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###
  # "Mix-in" the Fake module
  require 'crdb/fake.rb'
  include CRDB::Fake

  @@fake_method_to_value_hash = nil
  def (CRDB::Category).initialize_fake_method_to_value_hash()
    fake_codes = ['zz', 'zy']
    fake_descriptions = ['a fake code', 'another fake code']

    @@fake_method_to_value_hash =
    {
      'code'        => fake_codes,
      'description' => fake_descriptions,
    }
  end

  def (CRDB::Category).get_fake_method_to_value_hash()
    return @@fake_method_to_value_hash
  end

  def (CRDB::Category).delete_all_fakes()
    (CRDB::Category).initialize_fake_method_to_value_hash()
    fake_descriptions = @@fake_method_to_value_hash['description']
    (CRDB::Category).delete_all(["description = ?", fake_descriptions[0]])
    (CRDB::Category).delete_all(["description = ?", fake_descriptions[1]])
  end
  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###

 end # matches "class Category"
end # matches "module CRDB"
