module CRDB
 class Policy < ActiveRecord::Base

  has_one :resource, :class_name => "CRDB::Resource"

  ## VALIDATIONS
  validates_format_of :name, :with => /\A[a-z0-9_]+\z/
  validates_uniqueness_of :name
  validates_uniqueness_of :description

  def to_s
    id = self.id
    name = self.name
    description = self.description
    return "(id: #{id}, name: #{name}, description: #{description})"
  end

  def to_s_short
    return self.name
  end

  def eql?(policy)
    if (self.name.eql?(policy.name) && self.description.eql?(policy.description))
      return true
    else
      return false
    end
  end


  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###
  # "Mix-in" the Fake module
  require 'crdb/fake.rb'
  include CRDB::Fake

  @@fake_method_to_value_hash = nil
  def (CRDB::Policy).initialize_fake_method_to_value_hash()
    fake_names = ['accept_if_nice', 'never_on_sunday']
    fake_descriptions = ['Accept only if the person is nice', 'Never mind']

    @@fake_method_to_value_hash =
    {
      'name'        => fake_names,
      'description' => fake_descriptions,
    }
  end

  def (CRDB::Policy).get_fake_method_to_value_hash()
    return @@fake_method_to_value_hash
  end

  def (CRDB::Policy).delete_all_fakes()
    (CRDB::Policy).initialize_fake_method_to_value_hash()
    fake_descriptions = @@fake_method_to_value_hash['description']
    (CRDB::Policy).delete_all(["description = ?", fake_descriptions[0]])
    (CRDB::Policy).delete_all(["description = ?", fake_descriptions[1]])
  end
  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###


 end # matches "class Policy"
end # matches "module CRDB"
