# In case this is running on a server where the active record or active
# support libraries are in /usr/lib/ruby/1.8/:
# $:.push('/usr/lib/ruby/1.8/')

require 'active_support' # Is this necessary?

require 'crdb/remctl'

module CRDB
 class RemctlCaladmin < CRDB::Remctl

  def initialize
    super
    @type = 'cal-admin'
  end

  def help
    @service = 'help'
    return self.run()
  end

  def dump_attributes
    @service = 'dump-attributes'
    return self.run()
  end

  def find(substring)
    @service = 'find'
    @options = "#{substring}"
    return self.run()
  end

  def get_all_attributes(uid)
    @service = 'show-attribute'
    @options = "#{uid} ALL"
    return self.run()
  end

  # This sets an attribute. WARNING! Only suitable for non-multi-valued
  # attributes.
  def set_attribute(uid, attribute, value)
    @service = 'set-attribute'

    if (value.nil?)
      @options = "#{uid} #{attribute} null"
    else
      @options = "#{uid} #{attribute} \"#{value}\""
    end

    return self.run()
  end

  def set_policy(uid, policy)
    @service = 'policy'
    @options = "#{uid} #{policy}"
    return self.run()
  end

  def create(uid, display_name)
    @service = 'create'
    @options = %Q[#{uid} "#{display_name}"]
    # puts self.to_s
    return self.run()
  end

  # Share
  # share <resource|sunetid1> <sunetid2|ALL> <view|manager|admin|none> [/folder]
  def share(uid1, uid2, access, folder = '/Calendar')
    @service = 'share'
    @options = %Q[#{uid1} #{uid2} #{access} #{folder}]

    return self.run()
  end

  # list acls
  # listacl <resource_uid>
  def listacl(uid, folder = '/Calendar')
    @service = 'listacl'
    @options = %Q[#{uid} #{folder}]

    return self.run()
  end

 end # matches "class RemctlCaladmin"
end # matches "module CRDB"

